'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var ReactDOM = _interopDefault(require('react-dom'));
var PropTypes = _interopDefault(require('prop-types'));

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var body = document.body;

var Portal = function (_React$Component) {
  inherits(Portal, _React$Component);

  function Portal(props) {
    classCallCheck(this, Portal);

    var _this = possibleConstructorReturn(this, (Portal.__proto__ || Object.getPrototypeOf(Portal)).call(this, props));

    _this.el = document.createElement("div");
    return _this;
  }

  createClass(Portal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      body.appendChild(this.el);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      ReactDOM.unmountComponentAtNode(this.el);
      body.removeChild(this.el);
    }
  }, {
    key: "render",
    value: function render() {
      return ReactDOM.createPortal(this.props.children, this.el);
    }
  }]);
  return Portal;
}(React__default.Component);

Portal.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
};

var CreateYOLO = function CreateYOLO() {
  var count = 0;
  var wakeArr = [];

  return function (_React$Component) {
    inherits(YOLO, _React$Component);

    function YOLO(props) {
      classCallCheck(this, YOLO);

      var _this = possibleConstructorReturn(this, (YOLO.__proto__ || Object.getPrototypeOf(YOLO)).call(this, props));

      _this.state = {
        shouldMount: false
      };

      _this.setShouldMount = function (shouldMount) {
        _this.setState({ shouldMount: shouldMount });
      };

      return _this;
    }

    createClass(YOLO, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        count++;
        if (count === 1) {
          this.setShouldMount(true);
        }
        wakeArr.push(this.setShouldMount);
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        count--;
        var index = wakeArr.indexOf(this.setShouldMount);
        if (index > -1) {
          wakeArr.splice(index, 1);
        }
        if (count > 0) {
          wakeArr[0](true);
        }
      }
    }, {
      key: "render",
      value: function render() {
        return this.state.shouldMount && this.props.children;
      }
    }]);
    return YOLO;
  }(React__default.Component);
};

var YOLO = CreateYOLO();

YOLO.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
};

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".styles_backdrop__nv-Pu {\n  z-index: 1000;\n  background-color: #000000;\n  opacity: 0.7;\n  position: fixed;\n  height: 100%;\n  width: 100%;\n  top: 0;\n  left: 0;\n}\n";
var styles = { "backdrop": "styles_backdrop__nv-Pu" };
styleInject(css);

var Backdrop = function Backdrop(_ref) {
  var zIndex = _ref.zIndex,
      opacity = _ref.opacity,
      color = _ref.color;
  return React__default.createElement(
    Portal,
    null,
    React__default.createElement(
      YOLO,
      null,
      React__default.createElement("div", {
        className: styles.backdrop,
        style: _extends({}, opacity && { opacity: opacity }, color && { "background-color": color }, zIndex && { zIndex: zIndex })
      })
    )
  );
};

Backdrop.propTypes = {
  zIndex: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  opacity: PropTypes.number,
  color: PropTypes.string
};

var css$1 = ".styles_child_over_backdrop__3EbeD {\n  z-index: 1001;\n  position: relative;\n}\n\n.styles_box_shadow__2P8Ee {\n  box-shadow: 0 0 10px 10px #ffffff;\n}";
var styles$1 = { "child_over_backdrop": "styles_child_over_backdrop__3EbeD", "box_shadow": "styles_box_shadow__2P8Ee" };
styleInject(css$1);

var formatClassNames = function formatClassNames(classNames) {
  return classNames.reduce(function (acc, className) {
    return className ? acc + " " + className : acc;
  });
};

var retrieveBgColor = function retrieveBgColor(node) {
  if (!node.parentNode) {
    return "#ffffff";
  }

  var bgColor = window.getComputedStyle(node).getPropertyValue("background-color");
  var hasNodeBgColor = bgColor.split(",").length === 4 && bgColor.split(",")[3].trim() === "0)";

  return hasNodeBgColor ? retrieveBgColor(node.parentNode) : bgColor;
};

var StyledChildWrapper = function (_React$Component) {
  inherits(StyledChildWrapper, _React$Component);

  function StyledChildWrapper(props) {
    classCallCheck(this, StyledChildWrapper);

    var _this = possibleConstructorReturn(this, (StyledChildWrapper.__proto__ || Object.getPrototypeOf(StyledChildWrapper)).call(this, props));

    _this.state = {
      backgroundColor: undefined
    };

    _this.setBackground = function (backgroundColor) {
      _this.setState({ backgroundColor: backgroundColor });
    };

    _this.ref = React__default.createRef();
    return _this;
  }

  createClass(StyledChildWrapper, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var inheritParentBackgroundColor = this.props.inheritParentBackgroundColor;

      if (inheritParentBackgroundColor) {
        var node = this.ref.current;
        var bgColor = retrieveBgColor(node);
        this.setBackground(bgColor);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var backgroundColor = this.state.backgroundColor;
      var _props = this.props,
          style = _props.style,
          spotlightStyle = _props.spotlightStyle,
          enableShadow = _props.enableShadow;


      return React__default.Children.map(this.props.children, function (child, i) {
        var safeChild = child.type ? child : React__default.createElement(
          "span",
          null,
          child
        );

        var classNames = [safeChild.props.className, styles$1.child_over_backdrop, enableShadow && styles$1.box_shadow];
        var className = formatClassNames(classNames);

        return React__default.cloneElement(safeChild, {
          className: className,
          style: _extends({}, style, safeChild.props.style, backgroundColor && { backgroundColor: backgroundColor }, spotlightStyle),
          ref: _this2.ref
        });
      });
    }
  }]);
  return StyledChildWrapper;
}(React__default.Component);

StyledChildWrapper.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node]),
  enableShadow: PropTypes.bool,
  spotlightStyle: PropTypes.object,
  inheritParentBackgroundColor: PropTypes.bool
};

var Spotlight = function Spotlight(_ref) {
  var children = _ref.children,
      isActive = _ref.isActive,
      renderLabel = _ref.renderLabel,
      zIndex = _ref.zIndex,
      backdropOpacity = _ref.backdropOpacity,
      backdropColor = _ref.backdropColor,
      enableShadow = _ref.enableShadow,
      style = _ref.style,
      inheritParentBackgroundColor = _ref.inheritParentBackgroundColor;
  return isActive ? React__default.createElement(
    React__default.Fragment,
    null,
    React__default.Children.map(children, function (child) {
      return React__default.createElement(
        StyledChildWrapper,
        {
          inheritParentBackgroundColor: inheritParentBackgroundColor,
          enableShadow: enableShadow,
          style: _extends({}, zIndex && {
            zIndex: (+zIndex + 1).toString()
          }, style)
        },
        child
      );
    }),
    React__default.createElement(
      "div",
      { style: _extends({}, zIndex && { zIndex: zIndex }) },
      renderLabel
    ),
    React__default.createElement(Backdrop, {
      zIndex: zIndex,
      opacity: backdropOpacity,
      color: backdropColor
    })
  ) : children;
};

Spotlight.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node]),
  isActive: PropTypes.bool,
  renderLabel: PropTypes.func,
  zIndex: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  backdropOpacity: PropTypes.string,
  backdropColor: PropTypes.string,
  enableShadow: PropTypes.bool,
  style: PropTypes.object,
  inheritParentBackgroundColor: PropTypes.bool
};

var css$2 = ".styles_backdrop_content__23Pab {\n  z-index: 1001;\n  position: absolute;\n  padding: 5px;\n  background: white;\n\n}\n\n.styles_backdrop_content_center__37Ato {\n  z-index: 1001;\n  padding: 5px;\n  margin: 0;\n  background: white;\n  position: absolute;\n  top: 50%;\n  left: 50%;\n  margin-right: -50%;\n  transform: translate(-50%, -50%) \n}\n";
var styles$2 = { "backdrop_content": "styles_backdrop_content__23Pab", "backdrop_content_center": "styles_backdrop_content_center__37Ato" };
styleInject(css$2);

var LabelWrapper = function LabelWrapper(_ref) {
  var children = _ref.children,
      styleProp = _ref.style,
      zIndex = _ref.zIndex,
      center = _ref.center;

  var className = center ? styles$2.backdrop_content_center : styles$2.backdrop_content;
  var style = _extends({}, zIndex && { zIndex: zIndex }, styleProp);

  return React__default.createElement(
    "div",
    { className: className },
    React__default.createElement(
      "div",
      { style: style },
      children
    )
  );
};

LabelWrapper.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node]),
  centerLabel: PropTypes.bool
};

exports.default = Spotlight;
exports.LabelWrapper = LabelWrapper;
//# sourceMappingURL=index.js.map
